library(dplyr)

############ READ DATA
base_data = read.csv('Base_Data.csv')

############ STANDARDISE NAMES 
base_data$Team_1 = ifelse(as.character(base_data$Team_1) == "South Melbourne", "Sydney",
                    ifelse(as.character(base_data$Team_1) == "Footscray", "Western Bulldogs",
                      ifelse(as.character(base_data$Team_1) == "North Melbourne", "Kangaroos", as.character(base_data$Team_1))))

base_data$Team_2 = ifelse(as.character(base_data$Team_2) == "South Melbourne", "Sydney",
                    ifelse(as.character(base_data$Team_2) == "Footscray", "Western Bulldogs",
                      ifelse(as.character(base_data$Team_2) == "North Melbourne", "Kangaroos", as.character(base_data$Team_2))))


Year_1 = 1897
#Year_1 = 2000

# Calculate averages to use for year 1
Ave_Score_Year_1 = as.numeric(base_data %>% filter(Year == Year_1) %>% summarise(mean(Team_1_Score + Team_2_Score)/2))
Ave_Score_per_SS_Year_1 = as.numeric(base_data %>% filter(Year == Year_1) %>% summarise(mean((Team_1_Score + Team_2_Score)/(T1_SS + T2_SS))))


base_data = base_data[base_data$Year >= Year_1,]

########### BUILD TEAM DATA FRAME ############
num_games = dim(base_data)[1]

team_data = data.frame(
                Team = c(rep(" ",num_games*2)),
                Year = c(rep(1900,num_games*2)),
                Date = c(rep(" ",num_games*2)),
                Master_Game_Num = c(rep(-999,num_games*2)),
                Master_Round_Num = c(rep(-999,num_games*2)),
                Master_Round_Num_Full = c(rep(-999,num_games*2)),
                Round_Type = c(rep(" ",num_games*2)),
                Round_Num = c(rep(-999,num_games*2)),
                Round_Num_Full = c(rep(-999,num_games*2)),
                Venue = c(rep(" ",num_games*2)),
                Deemed_Status = c(rep(" ",num_games*2)),
                Team_Game_Num = c(rep(-999,num_games*2)),
                Team_Game_Num_At_Venue = c(rep(-999,num_games*2)),
                Opponent_Game_Num_At_Venue = c(rep(-999,num_games*2)),
                Result = c(rep(" ",num_games*2)),
                Own_Score = c(rep(-999,num_games*2)),
                Own_SS = c(rep(-999,num_games*2)),
                Own_MoSHBODS_Rating_Off = c(rep(-999,num_games*2)),
                Own_MoSHBODS_Rating_Def = c(rep(-999,num_games*2)),
                Opponent = c(rep(" ",num_games*2)),
                Opponent_Score = c(rep(-999,num_games*2)),
                Opponent_SS = c(rep(-999,num_games*2)),
                Opponent_MoSHBODS_Rating_Off = c(rep(-999,num_games*2)),
                Opponent_MoSHBODS_Rating_Def = c(rep(-999,num_games*2)),
                Expected_Margin = c(rep(-999,num_games*2)))
team_data_Team_1 = team_data[1:num_games,]
team_data_Team_2 = team_data[1:num_games,]

# Build for Team_1
team_data_Team_1$Team = as.character(base_data$Team_1)
team_data_Team_1$Year = base_data$Year
team_data_Team_1$Date = base_data$Date
team_data_Team_1$Master_Game_Num = base_data$Master_Game_Num
team_data_Team_1$Master_Round_Num = base_data$Master_Round_Num
team_data_Team_1$Master_Round_Num_Full = base_data$Master_Round_Num_Full
team_data_Team_1$Round_Type = base_data$Round_Type
team_data_Team_1$Round_Num = base_data$Round_Num
team_data_Team_1$Round_Num_Full = base_data$Round_Num_Full
team_data_Team_1$Venue = as.character(base_data$Venue)
team_data_Team_1$Deemed_Status = as.character(base_data$Team_1_Deemed_Status)
team_data_Team_1$Opponent = as.character(base_data$Team_2)
team_data_Team_1$Result = ifelse(base_data$Team_1_Score == base_data$Team_2_Score, "Draw",
                            ifelse(base_data$Team_1_Score > base_data$Team_2_Score, "Win","Loss"))
team_data_Team_1$Own_Score = base_data$Team_1_Score
team_data_Team_1$Own_SS = base_data$T1_SS
team_data_Team_1$Opponent_Score = base_data$Team_2_Score
team_data_Team_1$Opponent_SS = base_data$T2_SS

# Build for Team_2
team_data_Team_2$Team = as.character(base_data$Team_2)
team_data_Team_2$Year = base_data$Year
team_data_Team_2$Date = base_data$Date
team_data_Team_2$Master_Game_Num = base_data$Master_Game_Num
team_data_Team_2$Master_Round_Num = base_data$Master_Round_Num
team_data_Team_2$Master_Round_Num_Full = base_data$Master_Round_Num_Full
team_data_Team_2$Round_Type = base_data$Round_Type
team_data_Team_2$Round_Num = base_data$Round_Num
team_data_Team_2$Round_Num_Full = base_data$Round_Num_Full
team_data_Team_2$Venue = as.character(base_data$Venue)
team_data_Team_2$Deemed_Status = as.character(base_data$Team_2_Deemed_Status)
team_data_Team_2$Opponent = as.character(base_data$Team_1)
team_data_Team_2$Result = ifelse(base_data$Team_2_Score == base_data$Team_1_Score, "Draw",
                            ifelse(base_data$Team_2_Score > base_data$Team_1_Score, "Win","Loss"))
team_data_Team_2$Own_Score = base_data$Team_2_Score
team_data_Team_2$Own_SS = base_data$T2_SS
team_data_Team_2$Opponent_Score = base_data$Team_1_Score
team_data_Team_2$Opponent_SS = base_data$T1_SS

team_data = rbind(team_data_Team_1,team_data_Team_2)

team_data$Team_Region = ifelse(team_data$Team %in% c("GW Sydney"), "Sydney",
                        ifelse(team_data$Team %in% c("Carlton", "Collingwood", "Essendon", "Geelong", "Hawthorn",
                                                      "Kangaroos", "Melbourne", "Richmond", "St Kilda", "University",
                                                       "Western Bulldogs", "Fitzroy"), "Greater Melbourne",          
                        ifelse(team_data$Team %in% c("Brisbane Bears", "Gold Coast", "Brisbane Lions"), "Brisbane and Gold Coast",            
                        ifelse(team_data$Team %in% c("Adelaide", "Port Adelaide"), "Adelaide",            
                        ifelse(team_data$Team %in% c("Fremantle", "West Coast"), "West Australia","")))))

# Handle the South Melbourne to Sydney transition                        
team_data$Team_Region = ifelse(team_data$Team == "Sydney", ifelse(team_data$Year < 1982, "Greater Melbourne",
                                          "Sydney"), as.character(team_data$Team_Region))                        

team_data$Opponent_Region = ifelse(team_data$Opponent %in% c("GW Sydney"), "Sydney",
                        ifelse(team_data$Opponent %in% c("Carlton", "Collingwood", "Essendon", "Geelong", "Hawthorn",
                                                      "Kangaroos", "Melbourne", "Richmond", "St Kilda", "University",
                                                       "Western Bulldogs", "Fitzroy"), "Greater Melbourne",          
                        ifelse(team_data$Opponent %in% c("Brisbane Bears", "Gold Coast", "Brisbane Lions"), "Brisbane and Gold Coast",            
                        ifelse(team_data$Opponent %in% c("Adelaide", "Port Adelaide"), "Adelaide",            
                        ifelse(team_data$Opponent %in% c("Fremantle", "West Coast"), "West Australia","")))))

# Handle the South Melbourne to Sydney transition                        
team_data$Opponent_Region = ifelse(team_data$Opponent == "Sydney", ifelse(team_data$Year < 1982, "Greater Melbourne",
                                          "Sydney"), as.character(team_data$Opponent_Region))                        


team_data$Venue_Region = ifelse(team_data$Venue %in% c("Blacktown", "S.C.G.", "Stadium Australia", "Sydney Showground"), "Sydney",
                        ifelse(team_data$Venue %in% c("Manuka Oval", "Bruce Stadium"), "Canberra",                               
                        ifelse(team_data$Venue %in% c("Arden St", "Brunswick St", "Coburg Oval", "Corio Oval",
                                                       "Docklands", "East Melbourne", "Glenferrie Oval", "Junction Oval",
                                                       "Kardinia Park", "Lake Oval", "M.C.G.", "Moorabbin Oval", "Olympic Park",
                                                       "Princes Park", "Punt Rd", "Toorak Park", "Victoria Park", "Waverley Park",
                                                       "Western Oval", "Windy Hill", "Yarraville Oval"), "Greater Melbourne",          
                        ifelse(team_data$Venue %in% c("Albury", "Euroa", "Yallourn", "Eureka Stadium", "Riverway Stadium"), "Regional NSW Queensland and Victoria",  
                        ifelse(team_data$Venue %in% c("Bellerive Oval", "North Hobart", "York Park"), "Tasmania",  
                        ifelse(team_data$Venue %in% c("Brisbane Exhibition", "Carrara", "Cazaly's Stadium", "Gabba"), "Brisbane and Gold Coast",            
                        ifelse(team_data$Venue %in% c("Adelaide Oval", "Football Park"), "Adelaide",            
                        ifelse(team_data$Venue %in% c("Subiaco", "W.A.C.A.", "Perth Stadium"), "West Australia",            
                        ifelse(team_data$Venue %in% c("Marrara Oval", "Traeger Park"), "Northern Territory",            
                        ifelse(team_data$Venue %in% c("Wellington"), "NZ",
                        ifelse(team_data$Venue %in% c("Jiangwan Sports Centre"), "China", "")))))))))))            

# Create a game number field
for (aa in 1:(num_games*2))
{
   team_data$Team_Game_Num[aa] = sum((team_data$Team == team_data$Team[aa]) & (team_data$Master_Game_Num < team_data$Master_Game_Num[aa])) + 1
   team_data$Team_Game_Num_At_Venue[aa] = sum((team_data$Team == team_data$Team[aa]) & (team_data$Venue == team_data$Venue[aa]) &
                                              (team_data$Master_Game_Num < team_data$Master_Game_Num[aa])) + 1
   team_data$Opponent_Game_Num_At_Venue[aa] = sum((team_data$Team == team_data$Opponent[aa]) & (team_data$Venue == team_data$Venue[aa]) &
                                              (team_data$Master_Game_Num < team_data$Master_Game_Num[aa])) + 1
}

team_data$Actual_Margin_SS = team_data$Own_SS - team_data$Opponent_SS
team_data$Actual_Margin = team_data$Own_Score - team_data$Opponent_Score

write.csv(team_data, 'Initial Team Data.csv')

#############
calc_rating = function(Own_Rating_Off, Opp_Rating_Off, Own_Rating_Def, Opp_Rating_Def, Own_Score, Opp_Score, Deemed_Status, 
                                Round_Type, params, Exp_Score)
{
    # First calc the expected margin
    Venue_Adjustment = params[["VPV"]]

    # 1 RP = 1 point of margin expectation
    expected_margin_Off = (Own_Rating_Off-Opp_Rating_Def)+Venue_Adjustment/2
    expected_margin_Def = (Own_Rating_Def-Opp_Rating_Off)+Venue_Adjustment/2

    # Define cap as a margin
    actual_adj_margin_Off = ifelse(Own_Score - Opp_Score > params[["Cap"]],params[["Cap"]] + Opp_Score, Own_Score) - Exp_Score
    actual_adj_margin_Def = Exp_Score - ifelse(Opp_Score - Own_Score > params[["Cap"]], params[["Cap"]] + Own_Score, Opp_Score)

    new_rating_Off = Own_Rating_Off + params[["Multiplier_to_Use"]]*(actual_adj_margin_Off - expected_margin_Off)
    new_rating_Def = Own_Rating_Def + params[["Multiplier_to_Use"]]*(actual_adj_margin_Def - expected_margin_Def)

    return(c(new_rating_Off, new_rating_Def, expected_margin_Off, expected_margin_Def))
}

# Updates both team's VPVs for upcoming game
update_VPVs = function(VPV_lookup, in_data, current_row, days_to_average, games_before_average, out_of_region_default_VPV, final_VPV_fraction)
{

    Team = in_data$Team[current_row]
    Venue = in_data$Venue[current_row]
    Date_Proper = in_data$Date_Proper[current_row]
    
    # How many games played at the venue, excluding the current one, in the past days_to_average days?
    Team_Game_Num_At_Venue_in_Window = length(in_data$Date_Proper[(in_data$Team == Team) & (in_data$Venue == Venue) & 
                                              (Date_Proper - in_data$Date_Proper) <= days_to_average & 
                                              (Date_Proper > in_data$Date_Proper)])

    if (Team_Game_Num_At_Venue_in_Window < games_before_average)
    {
       if (as.character(in_data$Team_Region[current_row]) == as.character(in_data$Venue_Region[current_row]))
       {
          VPV_lookup$VPV[as.character(VPV_lookup$Team) == Team & as.character(VPV_lookup$Venue) == Venue] = 0 
       } else
         {
            VPV_lookup$VPV[as.character(VPV_lookup$Team) == Team & as.character(VPV_lookup$Venue) == Venue] = out_of_region_default_VPV 
         }
    }  else
      {

         Games_to_Use = in_data[in_data$Team == Team & in_data$Venue == Venue & 
                                  (Date_Proper - in_data$Date_Proper) <= days_to_average &
                                  (Date_Proper > in_data$Date_Proper),]

         VPV_lookup$VPV[as.character(VPV_lookup$Team) == Team & as.character(VPV_lookup$Venue) == Venue] = 
                                                             Mean_Reg * mean((Games_to_Use$Own_Score_Adj - 
                                                                   Games_to_Use$Opponent_Score_Adj) -
                                                                  (Games_to_Use$Own_MoSHBODS_Rating_Off + 
                                                                   Games_to_Use$Own_MoSHBODS_Rating_Def -
                                                                   Games_to_Use$Opponent_MoSHBODS_Rating_Off - 
                                                                   Games_to_Use$Opponent_MoSHBODS_Rating_Def), na.rm = TRUE)
      }
      
   if (in_data$Round_Type[current_row] == "Final")
   {
      VPV_lookup$VPV[as.character(VPV_lookup$Team) == Team & as.character(VPV_lookup$Venue) == Venue] = 
                   final_VPV_fraction * VPV_lookup$VPV[as.character(VPV_lookup$Team) == Team & as.character(VPV_lookup$Venue) == Venue]
   }
      
   return(VPV_lookup)
}

set_params = function(base_params, Year, Round_Num, Round_Type, Team_Game_Num, Deemed_Status, Team, Opponent, Venue)
{

    params = base_params
    # Use different splits for each season
     if (Round_Num < season_splits$Split_1[season_splits$Year == Year]) { params[["Multiplier_to_Use"]] = params[["Multiplier_1"]] } else 
     if (Round_Num < season_splits$Split_2[season_splits$Year == Year]) { params[["Multiplier_to_Use"]] = params[["Multiplier_2"]] } else 
     if (Round_Num < season_splits$Split_3[season_splits$Year == Year]) { params[["Multiplier_to_Use"]] = params[["Multiplier_3"]] } else 
     if (Round_Type == "Final") { params[["Multiplier_to_Use"]] = params[["Multiplier_5"]] } else 
     { params[["Multiplier_to_Use"]] = params[["Multiplier_4"]] }
    
    # Vary VPV by team and ground
    VPV_Own = VPV_lookup$VPV[VPV_lookup$Team == Team & VPV_lookup$Venue == Venue]
    VPV_Opponent = VPV_lookup$VPV[VPV_lookup$Team == Opponent & VPV_lookup$Venue == Venue]
    
    params[["VPV_Own"]] = VPV_Own
    params[["VPV_Opponent"]] = VPV_Opponent
    params[["VPV"]] = VPV_Own - VPV_Opponent

    return(params)
}    

library(compiler)
calc_rating = cmpfun(calc_rating)
update_VPVs = cmpfun(update_VPVs)
set_params = cmpfun(set_params)
###


### Start here for other than initial run
# Set parameters

Games_Before_Average = 8

Days_To_Average = 365*6

Out_Of_Region_Default_VPV = -9

Mean_Reg = 0.32

adjustment_factor = 0.75

Carryover = 0.65

Cap = 200

Alpha_1 = 0.117
Alpha_2 = 0.084
Alpha_3 = 0.093
Alpha_4 = 0.081
Alpha_5 = 0.055

Final_VPV_Fraction = 1.5

base_params = as.list(c(Cap,0,0,0,Alpha_1,Alpha_2,Alpha_3,Alpha_4,Alpha_5,Carryover,0,0.05))

# The Season_Splits file defines how each season is split into 5 segments: 4 H&A and 1 Finals
season_splits = read.csv('Season_Splits.csv')
                     
team_data = read.csv('Initial Team Data.csv')

base_data = read.csv('Base_Data.csv')
base_data$Team_1 = ifelse(as.character(base_data$Team_1) == "South Melbourne", "Sydney",
                    ifelse(as.character(base_data$Team_1) == "Footscray", "Western Bulldogs",
                      ifelse(as.character(base_data$Team_1) == "North Melbourne", "Kangaroos", as.character(base_data$Team_1))))
                      
base_data$Team_2 = ifelse(as.character(base_data$Team_2) == "South Melbourne", "Sydney",
                    ifelse(as.character(base_data$Team_2) == "Footscray", "Western Bulldogs",
                      ifelse(as.character(base_data$Team_2) == "North Melbourne", "Kangaroos", as.character(base_data$Team_2))))

base_data = base_data[base_data$Year >= Year_1,]

base_data$Venue = droplevels(base_data$Venue)

VPV_lookup = as.data.frame(expand.grid(unique(base_data$Team_1),unique(base_data$Venue),KEEP.OUT.ATTRS = FALSE))
names(VPV_lookup) = c("Team", "Venue")
VPV_lookup$VPV = 0

names(base_params) = c("Cap","VPV","VPV_Own","VPV_Opponent",
                         "Multiplier_1","Multiplier_2","Multiplier_3","Multiplier_4","Multiplier_5","Carryover",
                           "InitRating","Multiplier_to_Use")

team_data = team_data[order(team_data$Master_Game_Num),]

team_data$Own_MoSHBODS_Rating_After_Game_Off = c(rep(0,nrow(team_data)))
team_data$Own_MoSHBODS_Rating_After_Game_Def = c(rep(0,nrow(team_data)))
team_data$Own_MoSHBODS_Rating_Off = c(rep(0,nrow(team_data)))
team_data$Own_MoSHBODS_Rating_Def = c(rep(0,nrow(team_data)))
team_data$Opponent_MoSHBODS_Rating_Off = c(rep(0,nrow(team_data)))
team_data$Opponent_MoSHBODS_Rating_Def = c(rep(0,nrow(team_data)))
team_data$Own_Score_Adj = c(rep(0,nrow(team_data)))
team_data$Opponent_Score_Adj = c(rep(0,nrow(team_data)))
team_data$Expected_Margin_Off = c(rep(0,nrow(team_data)))
team_data$Expected_Margin_Def = c(rep(0,nrow(team_data)))
team_data$Expected_Margin_Real = c(rep(0,nrow(team_data)))
team_data$Expected_Own_Real = c(rep(0,nrow(team_data)))
team_data$Expected_Opponent_Real = c(rep(0,nrow(team_data)))
team_data$Expected_Own_Real_Adjusted = c(rep(0,nrow(team_data)))
team_data$Expected_Opponent_Real_Adjusted = c(rep(0,nrow(team_data)))
team_data$Own_Bias_Adjustment = c(rep(0,nrow(team_data)))
team_data$Opponent_Bias_Adjustment = c(rep(0,nrow(team_data)))

latest_ratings_Off = data.frame(Team = levels(as.factor(team_data$Team)), Rating = rep(base_params[["InitRating"]], length(levels(as.factor(team_data$Team)))))
latest_ratings_Def = data.frame(Team = levels(as.factor(team_data$Team)), Rating = rep(base_params[["InitRating"]], length(levels(as.factor(team_data$Team)))))

team_data$Date_Proper = as.Date(team_data$Date, format = "%d/%m/%Y")

Ave_Home_Conv_Year_1 = as.numeric(team_data %>% filter(Year == Year_1, Deemed_Status == "Home", Round_Type == "Home_Away") %>% summarise(sum(Own_Score - Own_SS)/5/sum(Own_SS)))
Ave_Away_Conv_Year_1 = as.numeric(team_data %>% filter(Year == Year_1, Deemed_Status == "Away", Round_Type == "Home_Away") %>% summarise(sum(Own_Score - Own_SS)/5/sum(Own_SS)))

# Calculate updated ratings at end of each game
for (aa in (1:nrow(team_data)))
{
    # Get the two VPVs to use for current game
    if ((aa %% 2) == 1)
    {
       VPV_lookup = update_VPVs(VPV_lookup, team_data, aa, Days_To_Average, Games_Before_Average, Out_Of_Region_Default_VPV, Final_VPV_Fraction)
       VPV_lookup = update_VPVs(VPV_lookup, team_data, aa+1, Days_To_Average, Games_Before_Average, Out_Of_Region_Default_VPV, Final_VPV_Fraction)
    }
    
    params = set_params(base_params, team_data$Year[aa], team_data$Round_Num[aa], team_data$Round_Type[aa],
                          team_data$Team_Game_Num[aa], team_data$Deemed_Status[aa], team_data$Team[aa], 
                          team_data$Opponent[aa], team_data$Venue[aa])

    # Patched 10 Apr 2017 to handle R1 byes
    is_first_game_in_season_for_team = ifelse(team_data$Round_Num[aa] == 
                                               min(team_data$Round_Num[team_data$Team == team_data$Team[aa] &
                                                   team_data$Year == team_data$Year[aa]]),"Yes","No")
    is_first_game_in_season_for_opponent = ifelse(team_data$Round_Num[aa] == 
                                               min(team_data$Round_Num[team_data$Team == team_data$Opponent[aa] &
                                                                       team_data$Year == team_data$Year[aa]]),"Yes","No")

    # Adjust Ratings at start of season to ensure sum is zero
    if (team_data$Master_Game_Num[aa] == min(team_data$Master_Game_Num[team_data$Year == team_data$Year[aa]]) & (aa %% 2) == 1)
    {
       teams_playing = unique(team_data$Team[team_data$Year == team_data$Year[aa]])
       agg_rating = sum(latest_ratings_Off$Rating[as.character(latest_ratings_Off$Team) %in% teams_playing]) + 
                    sum(latest_ratings_Def$Rating[as.character(latest_ratings_Def$Team) %in% teams_playing]) 
       latest_ratings_Off$Rating[as.character(latest_ratings_Off$Team) %in% teams_playing] = latest_ratings_Off$Rating[as.character(latest_ratings_Off$Team) %in% teams_playing] -
                                                                                             agg_rating/(2*length(teams_playing))
       latest_ratings_Def$Rating[as.character(latest_ratings_Def$Team) %in% teams_playing] = latest_ratings_Def$Rating[as.character(latest_ratings_Def$Team) %in% teams_playing] -
                                                                                             agg_rating/(2*length(teams_playing))
    }   

    team_data$Own_MoSHBODS_Rating_Off[aa] = ifelse(team_data$Team_Game_Num[aa] == 1, params[["InitRating"]], 
                                      ifelse(is_first_game_in_season_for_team == "Yes", params[["Carryover"]]*
                                        latest_ratings_Off$Rating[latest_ratings_Off$Team == team_data$Team[aa]]+(1-params[["Carryover"]])*params[["InitRating"]],
                                         latest_ratings_Off$Rating[latest_ratings_Off$Team == team_data$Team[aa]]))

    team_data$Own_MoSHBODS_Rating_Def[aa] = ifelse(team_data$Team_Game_Num[aa] == 1, params[["InitRating"]], 
                                      ifelse(is_first_game_in_season_for_team == "Yes", params[["Carryover"]]*
                                        latest_ratings_Def$Rating[latest_ratings_Def$Team == team_data$Team[aa]]+(1-params[["Carryover"]])*params[["InitRating"]],
                                         latest_ratings_Def$Rating[latest_ratings_Def$Team == team_data$Team[aa]]))
    
    Own_Previous_Rating_Off = team_data$Own_MoSHBODS_Rating_Off[aa]                                    
    Own_Previous_Rating_Def = team_data$Own_MoSHBODS_Rating_Def[aa]                                    
                                        
    team_data$Opponent_MoSHBODS_Rating_Off[aa] = ifelse(team_data$Team_Game_Num[((team_data$Master_Game_Num == team_data$Master_Game_Num[aa]) & 
                                                       (team_data$Team != team_data$Team[aa]))] == 1, params[["InitRating"]], 
                                           ifelse(is_first_game_in_season_for_opponent == "Yes", 
                                              params[["Carryover"]]*latest_ratings_Off$Rating[latest_ratings_Off$Team == 
                                                    team_data$Opponent[aa]]+(1-params[["Carryover"]])*params[["InitRating"]],
                                                     latest_ratings_Off$Rating[latest_ratings_Off$Team == team_data$Opponent[aa]]))

    team_data$Opponent_MoSHBODS_Rating_Def[aa] = ifelse(team_data$Team_Game_Num[((team_data$Master_Game_Num == team_data$Master_Game_Num[aa]) & 
                                                       (team_data$Team != team_data$Team[aa]))] == 1, params[["InitRating"]], 
                                           ifelse(is_first_game_in_season_for_opponent == "Yes", 
                                              params[["Carryover"]]*latest_ratings_Def$Rating[latest_ratings_Def$Team == 
                                                    team_data$Opponent[aa]]+(1-params[["Carryover"]])*params[["InitRating"]],
                                                     latest_ratings_Def$Rating[latest_ratings_Def$Team == team_data$Opponent[aa]]))

    Opponent_Previous_Rating_Off = team_data$Opponent_MoSHBODS_Rating_Off[aa]
    Opponent_Previous_Rating_Def = team_data$Opponent_MoSHBODS_Rating_Def[aa]
   
    # Set Expected SS and Conversion per team per game to average for previous X days 
    Exp_Score = ifelse(team_data$Year[aa] == Year_1, Ave_Score_Year_1, as.numeric(team_data %>% 
                            filter(Date_Proper < Date_Proper[aa], Date_Proper >= Date_Proper[aa] - Days_To_Average) %>% 
                            summarise(mean(Own_Score + Opponent_Score, na.rm = TRUE)/2)))
                            
    Ave_Score_per_SS = ifelse(team_data$Year[aa] == Year_1, Ave_Score_per_SS_Year_1, as.numeric(team_data %>% 
                           filter(Date_Proper < Date_Proper[aa], Date_Proper >= Date_Proper[aa] - Days_To_Average) %>% 
                           summarise(sum(Own_Score + Opponent_Score, na.rm = TRUE)/sum(Own_SS + Opponent_SS, na.rm = TRUE))))

    team_data$Own_Score_Adj[aa] = adjustment_factor*(team_data$Own_SS[aa] * Ave_Score_per_SS) + (1-adjustment_factor)*team_data$Own_Score[aa]
    team_data$Opponent_Score_Adj[aa] = adjustment_factor*(team_data$Opponent_SS[aa] * Ave_Score_per_SS) + (1-adjustment_factor)*team_data$Opponent_Score[aa]

    new_rating_and_expected_margin = calc_rating(Own_Previous_Rating_Off, Opponent_Previous_Rating_Off, 
                                                  Own_Previous_Rating_Def, Opponent_Previous_Rating_Def, 
                                                     team_data$Own_Score_Adj[aa], team_data$Opponent_Score_Adj[aa],
                                                       team_data$Deemed_Status[aa], team_data$Round_Type[aa], params, Exp_Score)
   
    team_data$Own_MoSHBODS_Rating_After_Game_Off[aa] = new_rating_and_expected_margin[1]
    team_data$Own_MoSHBODS_Rating_After_Game_Def[aa] = new_rating_and_expected_margin[2]

    # Record expected margins
    team_data$Expected_Margin_Off[aa] = new_rating_and_expected_margin[3]
    team_data$Expected_Margin_Def[aa] = new_rating_and_expected_margin[4]
    
    # Update both teams' Latest Ratings after new ratings have been determined
    if (aa/2 == round(aa/2,0))
    {
      latest_ratings_Off$Rating[latest_ratings_Off$Team == team_data$Team[aa-1]] = team_data$Own_MoSHBODS_Rating_After_Game_Off[aa-1] 
      latest_ratings_Off$Rating[latest_ratings_Off$Team == team_data$Team[aa]] = team_data$Own_MoSHBODS_Rating_After_Game_Off[aa] 

      latest_ratings_Def$Rating[latest_ratings_Def$Team == team_data$Team[aa-1]] = team_data$Own_MoSHBODS_Rating_After_Game_Def[aa-1] 
      latest_ratings_Def$Rating[latest_ratings_Def$Team == team_data$Team[aa]] = team_data$Own_MoSHBODS_Rating_After_Game_Def[aa] 

    }   
      
    # Record parameters used
    team_data$Cap[aa] = params[["Cap"]]
    team_data$VPV[aa] = params[["VPV"]]
    team_data$VPV_Own[aa] = params[["VPV_Own"]]
    team_data$VPV_Opponent[aa] = params[["VPV_Opponent"]]
    team_data$Multiplier_1[aa] = params[["Multiplier_1"]]    
    team_data$Multiplier_2[aa] = params[["Multiplier_2"]]    
    team_data$Multiplier_3[aa] = params[["Multiplier_3"]]    
    team_data$Multiplier_4[aa] = params[["Multiplier_4"]]    
    team_data$Multiplier_5[aa] = params[["Multiplier_5"]]    
    team_data$Carryover[aa] = params[["Carryover"]]      
    team_data$InitRating[aa] = params[["InitRating"]]   
    
    # Show progress
    # if (team_data$Round_Num[aa] == 1) { print(team_data$Year[aa])}

    team_data$Expected_Margin_Real[aa] = team_data$Expected_Margin_Off[aa]+team_data$Expected_Margin_Def[aa]

    ###  Amended 6/7/2016 to adopt 50% rule for VPV
    team_data$Expected_Own_Real[aa] = Exp_Score + (team_data$Own_MoSHBODS_Rating_Off[aa] - team_data$Opponent_MoSHBODS_Rating_Def[aa]) +
                                                 (team_data$VPV_Own[aa] - team_data$VPV_Opponent[aa])/2           

    team_data$Expected_Opponent_Real[aa] = Exp_Score + (team_data$Opponent_MoSHBODS_Rating_Off[aa] - team_data$Own_MoSHBODS_Rating_Def[aa]) + 
                                                (team_data$VPV_Opponent[aa] - team_data$VPV_Own[aa])/2
                                                
    recent_home_bias = as.numeric(team_data %>% 
                          filter(Round_Type == "Home_Away", Deemed_Status == "Home", Date_Proper < Date_Proper[aa], Date_Proper >= Date_Proper[aa] - Days_To_Average) %>% 
                                summarise(mean(Own_Score - Expected_Own_Real, na.rm = TRUE)))
    
    recent_away_bias = as.numeric(team_data %>% 
                          filter(Round_Type == "Home_Away", Deemed_Status == "Away", Date_Proper < Date_Proper[aa], Date_Proper >= Date_Proper[aa] - Days_To_Average) %>% 
                                summarise(mean(Own_Score - Expected_Own_Real, na.rm = TRUE)))

    recent_home_bias = ifelse(is.na(recent_home_bias), 0, recent_home_bias)
    recent_away_bias = ifelse(is.na(recent_away_bias), 0, recent_away_bias)


    # Make adjustments to expected scores and margins based on recent, historical bias
    team_data$Expected_Own_Real_Adjusted[aa] = ifelse(team_data$Round_Type[aa] == "Final", team_data$Expected_Own_Real[aa],
                                            ifelse(team_data$Deemed_Status[aa] == "Home", team_data$Expected_Own_Real[aa] + recent_home_bias,
                                                   team_data$Expected_Own_Real[aa] + recent_away_bias))
    
    team_data$Expected_Opponent_Real_Adjusted[aa] = ifelse(team_data$Round_Type[aa] == "Final", team_data$Expected_Opponent_Real[aa],
                                            ifelse(team_data$Deemed_Status[aa] == "Away", team_data$Expected_Opponent_Real[aa] + recent_home_bias,
                                                   team_data$Expected_Opponent_Real[aa] + recent_away_bias))

    team_data$Own_Bias_Adjustment[aa] = ifelse(team_data$Round_Type[aa] == "Final", 0,
                                            ifelse(team_data$Deemed_Status[aa] == "Home", recent_home_bias, recent_away_bias))

    team_data$Opponent_Bias_Adjustment[aa] = ifelse(team_data$Round_Type[aa] == "Final", 0,
                                            ifelse(team_data$Deemed_Status[aa] == "Home", recent_away_bias, recent_home_bias))
}

team_data$Own_MoSHBODS_Rating_After_Game_Combined = (team_data$Own_MoSHBODS_Rating_After_Game_Off + team_data$Own_MoSHBODS_Rating_After_Game_Def)
team_data$Own_MoSHBODS_Rating_Combined = (team_data$Own_MoSHBODS_Rating_Off + team_data$Own_MoSHBODS_Rating_Def)
team_data$Opponent_MoSHBODS_Rating_Combined = (team_data$Opponent_MoSHBODS_Rating_Off + team_data$Opponent_MoSHBODS_Rating_Def)
                                               
team_data$Expected_Margin_Real_Adjusted = team_data$Expected_Own_Real_Adjusted - team_data$Expected_Opponent_Real_Adjusted

team_data$Expected_Total = team_data$Expected_Own_Real + team_data$Expected_Opponent_Real

team_data$Expected_Total_Adjusted = team_data$Expected_Own_Real_Adjusted + team_data$Expected_Opponent_Real_Adjusted
    
##################### Calculate estimated victory probability using scoring model
library(mvtnorm)
library(emdbook)
library(moments)

reps = 100000

theta_home = 262 
theta_away = 109

size_H = 163
size_A = 96

cor_excess_SS = matrix(c(1,-0.24,-0.24,1), nrow = 2)

mean_vec = c(0,0)

team_data$Est_Margin_SD = 0
team_data$Est_Home_SD = 0
team_data$Est_Away_SD = 0
team_data$Est_Prob = 0
team_data$Est_Margin_SD_round = 0

team_data$Expected_Own_SS = 0
team_data$Expected_Opponent_SS = 0

# Choose games to create estimates for

#Starting_Year = 1902
Starting_Year = 2010
Starting_Round = 1
set.seed(57985)


# Create estimates - record om deemed home team row only
for (aa in as.vector(which(team_data$Year >= Starting_Year & team_data$Round_Num >= Starting_Round & team_data$Deemed_Status == "Home")))
{

    Ave_Score_per_SS = ifelse(team_data$Year[aa] == Year_1, Ave_Score_per_SS_Year_1, as.numeric(team_data %>% 
                           filter(Date_Proper < Date_Proper[aa], Date_Proper >= Date_Proper[aa] - Days_To_Average) %>% 
                           summarise(sum(Own_Score + Opponent_Score, na.rm = TRUE)/sum(Own_SS + Opponent_SS, na.rm = TRUE))))

    prob_conv_home = ifelse(team_data$Year[aa] == Year_1, Ave_Home_Conv_Year_1, as.numeric(team_data %>% 
                           filter(Date_Proper < Date_Proper[aa], Date_Proper >= Date_Proper[aa] - Days_To_Average, 
                                 Round_Type == "Home_Away", Deemed_Status == "Home") %>%
                                   summarise(sum(Own_Score - Own_SS, na.rm = TRUE)/5/sum(Own_SS, na.rm = TRUE))))
                           
    prob_conv_away = ifelse(team_data$Year[aa] == Year_1, Ave_Away_Conv_Year_1, as.numeric(team_data %>% 
                           filter(Date_Proper < Date_Proper[aa], Date_Proper >= Date_Proper[aa] - Days_To_Average, 
                                 Round_Type == "Home_Away", Deemed_Status == "Away") %>%
                                   summarise(sum(Own_Score - Own_SS, na.rm = TRUE)/5/sum(Own_SS, na.rm = TRUE))))

    team_data$Expected_Own_SS[aa] = team_data$Expected_Own_Real_Adjusted[aa]/Ave_Score_per_SS
    team_data$Expected_Opponent_SS[aa] = team_data$Expected_Opponent_Real_Adjusted[aa]/Ave_Score_per_SS

    mean_SS_home = team_data$Expected_Own_SS[aa]
    mean_SS_away = team_data$Expected_Opponent_SS[aa]
  
    score_home = rep(0,reps)
    score_away = rep(0,reps)
  
    # Generate bivariate Neg Binomials for home and away SS
    S <- cor_excess_SS #Correlation matrix
    AB <- rmvnorm(mean=c(0,0),sig=S,n=reps) #Our gaussian variables
    U <- pnorm(AB) #Now U is uniform - check using hist(U[,1]) or hist(U[,2])
    SS_home <- qnbinom(U[,1], size = size_H, mu = mean_SS_home)  #x is gamma distributed
    SS_away <- qnbinom(U[,2], size = size_A, mu = mean_SS_away) #y is beta distributed
  
    SS_home_conv = rbetabinom(reps, prob=prob_conv_home, size=SS_home, theta=theta_home)
    score_home = SS_home_conv * 6 + (SS_home-SS_home_conv)
  
    SS_away_conv = rbetabinom(reps, prob=prob_conv_away, size=SS_away, theta=theta_away)
    score_away = SS_away_conv * 6 + (SS_away-SS_away_conv)
  
    team_data$Est_Margin_SD[aa] = sd(score_home-score_away)
    team_data$Est_Home_SD[aa] = sd(score_home)
    team_data$Est_Away_SD[aa] = sd(score_away)
    team_data$Est_Prob[aa] = mean(score_home > score_away) + 0.5*mean(score_home == score_away)
    team_data$Est_Margin_SD_round[aa] = round(team_data$Est_Margin_SD[aa],0)    
    
    print(aa)
}

##############

write.csv(team_data, 'Simplified Base and Rating Data.csv')
write.csv(VPV_lookup, 'VPV.csv')


# Prepare outputs for current round
year_to_output = 2020
round_to_output = 1

team_data_to_use = team_data[team_data$Deemed_Status == "Home" & team_data$Year == year_to_output & 
                             team_data$Round_Num == round_to_output,]

output_df = data.frame(Home_Team = team_data_to_use$Team,
                       Home_Team_Defensive_Rating = round(team_data_to_use$Own_MoSHBODS_Rating_Def,3),
                       Home_Team_Offensive_Rating = round(team_data_to_use$Own_MoSHBODS_Rating_Off,3),
                       Away_Team = team_data_to_use$Opponent,
                       Away_Team_Defensive_Rating = round(team_data_to_use$Opponent_MoSHBODS_Rating_Def,3),
                       Away_Team_Offensive_Rating = round(team_data_to_use$Opponent_MoSHBODS_Rating_Off,3),  
                       Net_Venue_Effect = round(team_data_to_use$VPV_Own - team_data_to_use$VPV_Opponent,3),
                       Net_Bias_Adjustment = round(team_data_to_use$Own_Bias_Adjustment - team_data_to_use$Opponent_Bias_Adjustment,3),
                       Expected_Margin = round(team_data_to_use$Expected_Margin_Real_Adjusted,3),
                       Home_Team_Expected_Score = round(team_data_to_use$Expected_Own_Real_Adjusted,3),
                       Away_Team_Expected_Score = round(team_data_to_use$Expected_Opponent_Real_Adjusted,3),
                       Expected_Total = round(team_data_to_use$Expected_Total_Adjusted,3),
                       Home_Team_Probability = round(team_data_to_use$Est_Prob,3), 
                       Recommended_Margin_SD = team_data_to_use$Est_Margin_SD_round, 
                       stringsAsFactors = FALSE)         

write.csv(output_df, "Data for Round.csv")                       



############
# Uncomment for Metrics 
#View(team_data %>% filter(Deemed_Status == "Home") %>% group_by(Year, Round_Type) %>% 
#                                     summarise(MAE_Margin = mean(abs(Own_Score - Opponent_Score - Expected_Margin_Real_Adjusted)),
#                                               MAE_Total = mean(abs(Own_Score + Opponent_Score - Expected_Total_Adjusted)),
#                                               MAE_Home = mean(abs(Own_Score - Expected_Own_Real_Adjusted)),
#                                               MAE_Away = mean(abs(Opponent_Score - Expected_Opponent_Real_Adjusted)),
#                                               LPS = mean(ifelse(Own_Score > Opponent_Score, 1+log(Est_Prob,2), 
#                                                                ifelse(Own_Score < Opponent_Score, 1+log(1-Est_Prob,2), 
#                                                                 0.5*(1+log(Est_Prob,2))+0.5*(1+log(1-Est_Prob,2)))))))
#                                               
#View(team_data %>% filter(Deemed_Status == "Home", Year == 2019) %>% group_by(Year) %>% 
#                                     summarise(MAE_Margin = mean(abs(Own_Score - Opponent_Score - Expected_Margin_Real_Adjusted)),
#                                               MAE_Total = mean(abs(Own_Score + Opponent_Score - Expected_Total_Adjusted)),
#                                               MAE_Home = mean(abs(Own_Score - Expected_Own_Real_Adjusted)),
#                                               MAE_Away = mean(abs(Opponent_Score - Expected_Opponent_Real_Adjusted)),
#                                               LPS = mean(ifelse(Own_Score > Opponent_Score, 1+log(Est_Prob,2), 
#                                                                ifelse(Own_Score < Opponent_Score, 1+log(1-Est_Prob,2), 
#                                                                 0.5*(1+log(Est_Prob,2))+0.5*(1+log(1-Est_Prob,2)))))))
#
#View(team_data %>% filter(Deemed_Status == "Home", Year > 2009) %>% group_by(Round_Type) %>% 
#                                     summarise(Margin_Bias = mean(Own_Score - Opponent_Score - Expected_Margin_Real_Adjusted),
#                                               Total_Bias = mean(Own_Score + Opponent_Score - Expected_Total_Adjusted),
#                                               Home_Bias = mean(Own_Score - Expected_Own_Real_Adjusted),
#                                               Away_Bias = mean(Opponent_Score - Expected_Opponent_Real_Adjusted)))
#
#View(team_data %>% group_by(Team) %>% 
#                                     summarise(Margin_Bias = mean(Own_Score - Opponent_Score - Expected_Margin_Real_Adjusted),
#                                               Total_Bias = mean(Own_Score + Opponent_Score - Expected_Total_Adjusted),
#                                               Home_Bias = mean(Own_Score - Expected_Own_Real_Adjusted),
#                                               Away_Bias = mean(Opponent_Score - Expected_Opponent_Real_Adjusted)))
#
#
#View(team_data %>% filter(Team == "Gold Coast") %>% group_by(Year) %>% 
#                                     summarise(Margin_Bias = mean(Own_Score - Opponent_Score - Expected_Margin_Real_Adjusted),
#                                               Total_Bias = mean(Own_Score + Opponent_Score - Expected_Total_Adjusted),
#                                               Home_Bias = mean(Own_Score - Expected_Own_Real_Adjusted),
#                                               Away_Bias = mean(Opponent_Score - Expected_Opponent_Real_Adjusted)))
#
#View(team_data %>% group_by(Team, Year) %>% 
#                                     summarise(Margin_Bias = mean(Own_Score - Opponent_Score - Expected_Margin_Real_Adjusted),
#                                               Total_Bias = mean(Own_Score + Opponent_Score - Expected_Total_Adjusted),
#                                               Home_Bias = mean(Own_Score - Expected_Own_Real_Adjusted),
#                                               Away_Bias = mean(Opponent_Score - Expected_Opponent_Real_Adjusted)))


 ss = data.frame(team_data %>% filter(Deemed_Status == "Home") %>% group_by(Year, Round_Type) %>% 
                                     summarise(Num_Games = length(Year),
                                               MAE_Margin = mean(abs(Own_Score - Opponent_Score - Expected_Margin_Real_Adjusted)),
                                               MAE_Total = mean(abs(Own_Score + Opponent_Score - Expected_Total_Adjusted)),
                                               MAE_Home = mean(abs(Own_Score - Expected_Own_Real_Adjusted)),
                                               MAE_Away = mean(abs(Opponent_Score - Expected_Opponent_Real_Adjusted)),
                                               LPS = mean(ifelse(Own_Score > Opponent_Score, 1+log(Est_Prob,2), 
                                                                ifelse(Own_Score < Opponent_Score, 1+log(1-Est_Prob,2), 
                                                                 0.5*(1+log(Est_Prob,2))+0.5*(1+log(1-Est_Prob,2)))))))
                                                                 
 write.csv(ss, 'Season Performances.csv')                                                                 
